From ea25ac8df59a608c98c91d3681f921203f71b8c3 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 11 2020 19:04:08 +0000
Subject: [PATCH 1353/2232] Enforce use of extern "C++" as the ABI string


---

diff --git a/syntax/parse.rs b/syntax/parse.rs
index b557584..d62899e 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -285,9 +285,9 @@ fn parse_lang(abi: &Abi) -> Result<Lang> {
         }
     };
     match name.value().as_str() {
-        "C" | "C++" => Ok(Lang::Cxx),
+        "C++" => Ok(Lang::Cxx),
         "Rust" => Ok(Lang::Rust),
-        _ => Err(Error::new_spanned(abi, "unrecognized ABI")),
+        _ => Err(Error::new_spanned(abi, "unrecognized ABI, requires either \"C++\" or \"Rust\"")),
     }
 }
 
diff --git a/tests/ui/multiple_parse_error.stderr b/tests/ui/multiple_parse_error.stderr
index 4189507..7c89129 100644
--- a/tests/ui/multiple_parse_error.stderr
+++ b/tests/ui/multiple_parse_error.stderr
@@ -4,7 +4,7 @@ error: struct with generic parameters is not supported yet
 3 |     struct Monad<T>;
   |     ^^^^^^^^^^^^^^^
 
-error: unrecognized ABI
+error: unrecognized ABI, requires either "C++" or "Rust"
  --> $DIR/multiple_parse_error.rs:5:5
   |
 5 |     extern "Haskell" {}

